#property copyright "Jeff"
#property link      "wolfboy@att.net"

#property indicator_separate_window
#property indicator_levelcolor Black
#property indicator_buffers 7
#property indicator_color1 LimeGreen
#property indicator_color2 DarkGreen
#property indicator_color3 Red
#property indicator_color4 Maroon
#property indicator_color5 CLR_NONE
#property indicator_color6 Black
#property indicator_color7 Black
#property indicator_width1 4

extern int FastEMA = 35;
extern int SlowEMA = 70;
extern int SignalEMA = 1;
extern int MAofSignalPer = 24;
double G_ibuf_92[];
double G_ibuf_96[];
double G_ibuf_100[];
double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
double G_ibuf_116[];

int init() {
   IndicatorBuffers(7);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(4, DRAW_NONE);
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID);
   SetIndexStyle(6, DRAW_LINE, STYLE_DOT);
   SetIndexDrawBegin(1, SignalEMA);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, G_ibuf_104);
   SetIndexBuffer(1, G_ibuf_108);
   SetIndexBuffer(2, G_ibuf_112);
   SetIndexBuffer(3, G_ibuf_116);
   SetIndexBuffer(4, G_ibuf_92);
   SetIndexBuffer(5, G_ibuf_96);
   SetIndexBuffer(6, G_ibuf_100);
   IndicatorShortName("MACD(" + FastEMA + ", " + SlowEMA + ", " + SignalEMA + ", " + MAofSignalPer + ")");
   SetIndexLabel(4, "MACD");
   SetIndexLabel(5, "Signal");
   SetIndexLabel(6, "MAofSignal");
   return (0);
}

int start() {
   double Ld_8;
   int Li_16 = IndicatorCounted();
   if (Li_16 > 0) Li_16--;
   int Li_0 = Bars - Li_16;
   for (int Li_4 = 0; Li_4 < Li_0; Li_4++) G_ibuf_92[Li_4] = iMA(NULL, 0, FastEMA, 0, MODE_EMA, PRICE_CLOSE, Li_4) - iMA(NULL, 0, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, Li_4);
   for (Li_4 = 0; Li_4 < Li_0; Li_4++) G_ibuf_96[Li_4] = iMAOnArray(G_ibuf_92, Bars, SignalEMA, 0, MODE_EMA, Li_4);
   for (Li_4 = 0; Li_4 < Li_0; Li_4++) G_ibuf_100[Li_4] = iMAOnArray(G_ibuf_96, Bars, MAofSignalPer, 0, MODE_EMA, Li_4);
   for (Li_4 = Bars - Max(Li_16 - 1, 1); Li_4 >= 0; Li_4--) {
      Ld_8 = G_ibuf_92[Li_4];
      if (Ld_8 > 0.0) {
         if (Ld_8 > G_ibuf_92[Li_4 + 1]) {
            G_ibuf_104[Li_4] = Ld_8;
            G_ibuf_108[Li_4] = 0;
            continue;
         }
         G_ibuf_104[Li_4] = 0;
         G_ibuf_108[Li_4] = Ld_8;
      } else {
         if (Ld_8 < G_ibuf_92[Li_4 + 1]) {
            G_ibuf_112[Li_4] = 0;
            G_ibuf_116[Li_4] = Ld_8;
         } else {
            G_ibuf_112[Li_4] = Ld_8;
            G_ibuf_116[Li_4] = 0;
         }
      }
   }
   return (0);
}

int Max(int Ai_0, int Ai_4) {
   if (Ai_0 > Ai_4) return (Ai_0);
   return (Ai_4);
}
